Index: test/sasdataloader/test/testplugings.py
===================================================================
--- test/sasdataloader/test/testplugings.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ test/sasdataloader/test/testplugings.py	(revision 17c943656cb7c598b2d5cf9530ed6227d88ae6f9)
@@ -3,4 +3,5 @@
 """
 
+import os
 import unittest
 from sas.sascalc.dataloader.loader import  Loader, Registry
@@ -41,7 +42,10 @@
         # Create module
         import zipfile
-        z = zipfile.PyZipFile("plugins.zip", 'w')
+        f_name = "plugins.zip"
+        z = zipfile.PyZipFile(f_name, 'w')
         z.writepy("../plugins", "")
         z.close()
+        if os.path.isfile(f_name):
+            os.remove(f_name)
         
     def testplugin_checksetup(self):
Index: test/sasdataloader/test/utest_abs_reader.py
===================================================================
--- test/sasdataloader/test/utest_abs_reader.py	(revision dd11014add466ed4ba0564fcf61e5880d53e6c8b)
+++ test/sasdataloader/test/utest_abs_reader.py	(revision c551bb3b1844a2c446021559f24b790187450d46)
@@ -2,4 +2,5 @@
     Unit tests for data manipulations
 """
+from __future__ import print_function
 
 import unittest
@@ -8,14 +9,20 @@
 from sas.sascalc.dataloader.loader import Loader
 from sas.sascalc.dataloader.readers.IgorReader import Reader as IgorReader
+from sas.sascalc.dataloader.readers.abs_reader import Reader as AbsReader
+from sas.sascalc.dataloader.readers.hfir1d_reader import Reader as HFIRReader
+from sas.sascalc.dataloader.readers.danse_reader import Reader as DANSEReader
+from sas.sascalc.dataloader.readers.cansas_reader import Reader as CANSASReader
+
 from sas.sascalc.dataloader.data_info import Data1D
  
 import os.path
 
+
 class abs_reader(unittest.TestCase):
     
     def setUp(self):
-        from sas.sascalc.dataloader.readers.abs_reader import Reader
-        self.data = Reader().read("jan08002.ABS")
-        
+        reader = AbsReader()
+        self.data = reader.read("jan08002.ABS")
+
     def test_abs_checkdata(self):
         """
@@ -61,10 +68,17 @@
     def test_checkdata2(self):
         self.assertEqual(self.data.dy[126], 1)
-        
+
+    def test_generic_loader(self):
+        # the generic loader should work as well
+        data = Loader().load("jan08002.ABS")
+        self.assertEqual(data.meta_data['loader'], "IGOR 1D")
+
+
 class hfir_reader(unittest.TestCase):
-    
+
     def setUp(self):
-        self.data = Loader().load("S2-30dq.d1d")
-        
+        reader = HFIRReader()
+        self.data = reader.read("S2-30dq.d1d")
+
     def test_hfir_checkdata(self):
         """
@@ -83,5 +97,10 @@
         self.assertEqual(self.data.dy[1], 0.000315)
         self.assertEqual(self.data.dx[1], 0.008249)
-        
+
+    def test_generic_loader(self):
+        # the generic loader should work as well
+        data = Loader().load("S2-30dq.d1d")
+        self.assertEqual(data.meta_data['loader'], "HFIR 1D")
+
 
 class igor_reader(unittest.TestCase):
@@ -137,5 +156,6 @@
     
     def setUp(self):
-        self.data = Loader().load("MP_New.sans")
+        reader = DANSEReader()
+        self.data = reader.read("MP_New.sans")
 
     def test_checkdata(self):
@@ -171,11 +191,22 @@
         self.assertEqual(self.data.err_data[2], 2.06313)
 
+    def test_generic_loader(self):
+        # the generic loader should work as well
+        data = Loader().load("MP_New.sans")
+        self.assertEqual(data.meta_data['loader'], "DANSE")
+
  
 class cansas_reader(unittest.TestCase):
     
     def setUp(self):
+        reader = CANSASReader()
+        data = reader.read("cansas1d.xml")
+        self.data = data[0]
+
+    def test_generic_loader(self):
+        # the generic loader should work as well
         data = Loader().load("cansas1d.xml")
-        self.data = data[0]
- 
+        self.assertEqual(data[0].meta_data['loader'], "CanSAS XML 1D")
+
     def test_cansas_checkdata(self):
         self.assertEqual(self.data.filename, "cansas1d.xml")
@@ -190,5 +221,4 @@
             tests won't pass
         """
-        
         self.assertEqual(self.data.run[0], "1234")
         self.assertEqual(self.data.meta_data['loader'], "CanSAS XML 1D")
@@ -264,15 +294,15 @@
             self.assertEqual(item.distance_unit,'mm')
 
-            if item.size.x==50 \
-                and item.distance==11000.0 \
-                and item.name=='source' \
-                and item.type=='radius':
+            if item.size.x == 50 \
+                and item.distance == 11000.0 \
+                and item.name == 'source' \
+                and item.type == 'radius':
                 _found1 = True
-            elif item.size.x==1.0 \
-                and item.name=='sample' \
-                and item.type=='radius':
+            elif item.size.x == 1.0 \
+                and item.name == 'sample' \
+                and item.type == 'radius':
                 _found2 = True
                 
-        if _found1==False or _found2==False:
+        if _found1 == False or _found2 == False:
             raise RuntimeError, "Could not find all data %s %s" % (_found1, _found2) 
             
@@ -309,28 +339,21 @@
             self.assertTrue(item.date in ['04-Sep-2007 18:35:02',
                                           '03-SEP-2006 11:42:47'])
-            print item.term
+            print(item.term)
             for t in item.term:
-                if t['name']=="ABS:DSTAND" \
-                    and t['unit']=='mm' \
-                    and float(t['value'])==1.0:
+                if (t['name'] == "ABS:DSTAND"
+                    and t['unit'] == 'mm'
+                    and float(t['value']) == 1.0):
                     _found_term2 = True
-                elif t['name']=="radialstep" \
-                    and t['unit']=='mm' \
-                    and float(t['value'])==10.0:
+                elif (t['name'] == "radialstep"
+                      and t['unit'] == 'mm'
+                      and float(t['value']) == 10.0):
                     _found_term1 = True
                     
-        if _found_term1==False or _found_term2==False:
-            raise RuntimeError, "Could not find all process terms %s %s" % (_found_term1, _found_term2) 
-            
-        
-        
+        if _found_term1 == False or _found_term2 == False:
+            raise RuntimeError, "Could not find all process terms %s %s" % (_found_term1, _found_term2)
         
     def test_writer(self):
-        from sas.sascalc.dataloader.readers.cansas_reader import Reader
-        r = Reader()
-        x = np.ones(5)
-        y = np.ones(5)
-        dy = np.ones(5)
-        
+        r = CANSASReader()
+
         filename = "write_test.xml"
         r.write(filename, self.data)
@@ -339,4 +362,6 @@
         self.assertEqual(self.data.filename, filename)
         self._checkdata()
+        if os.path.isfile(filename):
+            os.remove(filename)
         
     def test_units(self):
@@ -346,5 +371,5 @@
         """
         filename = "cansas1d_units.xml"
-        data = Loader().load(filename)
+        data = CANSASReader().read(filename)
         self.data = data[0]
         self.assertEqual(self.data.filename, filename)
@@ -357,5 +382,5 @@
         """
         filename = "cansas1d_badunits.xml"
-        data = Loader().load(filename)
+        data = CANSASReader().read(filename)
         self.data = data[0]
         self.assertEqual(self.data.filename, filename)
@@ -366,8 +391,7 @@
         
         self.assertEqual(self.data.meta_data['loader'], "CanSAS XML 1D")
-        print self.data.errors
+        print(self.data.errors)
         self.assertEqual(len(self.data.errors), 1)
-        
-        
+
     def test_slits(self):
         """
@@ -375,5 +399,5 @@
         """
         filename = "cansas1d_slit.xml"
-        data = Loader().load(filename)
+        data = CANSASReader().read(filename)
         self.data = data[0]
         self.assertEqual(self.data.filename, filename)
@@ -397,6 +421,5 @@
         self.assertEqual(self.data.run_name['1234'], 'run name')
         self.assertEqual(self.data.title, "Test title")
-        
-            
+
 
 if __name__ == '__main__':
Index: test/sasdataloader/test/utest_cansas.py
===================================================================
--- test/sasdataloader/test/utest_cansas.py	(revision 7432acb919f4013119ca918a73350297e0d4c93f)
+++ test/sasdataloader/test/utest_cansas.py	(revision 1fc50fb2f9e67f986acaa06fc7cbcba6b1edd00a)
@@ -46,5 +46,6 @@
         self.schema_1_0 = "cansas1d_v1_0.xsd"
         self.schema_1_1 = "cansas1d_v1_1.xsd"
-
+        self.write_1_0_filename = "isis_1_0_write_test.xml"
+        self.write_1_1_filename = "isis_1_1_write_test.xml"
 
     def get_number_of_entries(self, dictionary, name, i):
@@ -56,5 +57,4 @@
         return name
 
-
     def test_invalid_xml(self):
         """
@@ -62,6 +62,5 @@
         """
         invalid = StringIO.StringIO('<a><c></b></a>')
-        reader = XMLreader(invalid)
-
+        XMLreader(invalid)
 
     def test_xml_validate(self):
@@ -82,5 +81,4 @@
         self.assertFalse(xmlschema.validate(invalid))
 
-
     def test_real_xml(self):
         reader = XMLreader(self.xml_valid, self.schema_1_0)
@@ -90,5 +88,4 @@
         else:
             self.assertFalse(valid)
-
 
     def _check_data(self, data):
@@ -105,18 +102,13 @@
         self.assertTrue(data.meta_data["xmlpreprocess"] is not None)
 
-
     def _check_data_1_1(self, data):
         spectrum = data.trans_spectrum[0]
         self.assertTrue(len(spectrum.wavelength) == 138)
 
-
     def test_cansas_xml(self):
-        filename = "isis_1_1_write_test.xml"
         xmlreader = XMLreader(self.isis_1_1, self.schema_1_1)
         valid = xmlreader.validate_xml()
         xmlreader.set_processing_instructions()
         self.assertTrue(valid)
-        fo = open(self.isis_1_1)
-        str = fo.read()
         reader_generic = Loader()
         dataloader = reader_generic.load(self.isis_1_1)
@@ -128,12 +120,12 @@
             self._check_data(cansasreader[i])
             self._check_data_1_1(cansasreader[i])
-            reader_generic.save(filename, dataloader[i], None)
-            fo = open(filename)
-            str = fo.read()
+            reader_generic.save(self.write_1_1_filename, dataloader[i], None)
             reader2 = Loader()
-            return_data = reader2.load(filename)
+            self.assertTrue(os.path.isfile(self.write_1_1_filename))
+            return_data = reader2.load(self.write_1_1_filename)
             written_data = return_data[0]
             self._check_data(written_data)
-
+        if os.path.isfile(self.write_1_1_filename):
+            os.remove(self.write_1_1_filename)
 
     def test_double_trans_spectra(self):
@@ -144,5 +136,4 @@
         for item in data:
             self._check_data(item)
-
 
     def test_entry_name_recurse(self):
@@ -155,7 +146,5 @@
         self.assertTrue(len(d) == 6)
 
-
     def test_load_cansas_file(self):
-        valid = []
         reader1 = XMLreader(self.xml_valid, self.schema_1_0)
         self.assertTrue(reader1.validate_xml())
@@ -173,5 +162,4 @@
         self.assertFalse(reader7.validate_xml())
 
-
     def test_invalid_cansas(self):
         list = self.loader.load(self.cansas1d_notitle)
@@ -184,10 +172,9 @@
         self.assertTrue(data.detector[0].distance == 4150)
 
-
     def test_old_cansas_files(self):
         reader1 = XMLreader(self.cansas1d, self.schema_1_0)
         self.assertTrue(reader1.validate_xml())
         file_loader = Loader()
-        file1 = file_loader.load(self.cansas1d)
+        file_loader.load(self.cansas1d)
         reader2 = XMLreader(self.cansas1d_units, self.schema_1_0)
         self.assertTrue(reader2.validate_xml())
@@ -197,7 +184,5 @@
         self.assertTrue(reader4.validate_xml())
 
-
     def test_save_cansas_v1_0(self):
-        filename = "isis_1_0_write_test.xml"
         xmlreader = XMLreader(self.isis_1_0, self.schema_1_0)
         valid = xmlreader.validate_xml()
@@ -210,13 +195,15 @@
             self._check_data(dataloader[i])
             self._check_data(cansasreader[i])
-            reader_generic.save(filename, dataloader[i], None)
+            reader_generic.save(self.write_1_0_filename, dataloader[i], None)
             reader2 = Reader()
-            return_data = reader2.read(filename)
+            self.assertTrue(os.path.isfile(self.write_1_0_filename))
+            return_data = reader2.read(self.write_1_0_filename)
             written_data = return_data[0]
-            xmlwrite = XMLreader(filename, self.schema_1_0)
+            XMLreader(self.write_1_0_filename, self.schema_1_0)
             valid = xmlreader.validate_xml()
             self.assertTrue(valid)
             self._check_data(written_data)
-
+        if os.path.isfile(self.write_1_0_filename):
+            os.remove(self.write_1_0_filename)
 
     def test_processing_instructions(self):
@@ -224,5 +211,5 @@
         valid = reader.validate_xml()
         if valid:
-            ## find the processing instructions and make into a dictionary
+            # find the processing instructions and make into a dictionary
             dic = self.get_processing_instructions(reader)
             self.assertTrue(dic == {'xml-stylesheet': \
@@ -232,8 +219,7 @@
             xmldoc = minidom.parseString(xml)
 
-            ## take the processing instructions and put them back in
+            # take the processing instructions and put them back in
             xmldoc = self.set_processing_instructions(xmldoc, dic)
-            xml_output = xmldoc.toprettyxml()
-
+            xmldoc.toprettyxml()
 
     def set_processing_instructions(self, minidom_object, dic):
@@ -243,5 +229,4 @@
             minidom_object.insertBefore(pi, xmlroot)
         return minidom_object
-
 
     def get_processing_instructions(self, xml_reader_object):
Index: test/sasrealspace/test/early_test.py
===================================================================
--- test/sasrealspace/test/early_test.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ test/sasrealspace/test/early_test.py	(revision aaf5e497ff1af2aa7b8b3d361ab951e2a0ca7c93)
@@ -1,2 +1,3 @@
+from __future__ import print_function
 
 import VolumeCanvas
@@ -30,16 +31,16 @@
         t_0 = time.time()
         value_1 = 1.0e8*canvas.getIq(0.1)
-        print "density = 0.1:  output=%g  time=%g" % (value_1, time.time()-t_0)
+        print("density = 0.1:  output=%g  time=%g" % (value_1, time.time()-t_0))
         
         t_0 = time.time()
         canvas.setParam('lores_density', 1)
         value_1 = 1.0e8*canvas.getIq(0.1)
-        print "density = 1000:  output=%g  time=%g" % (value_1, time.time()-t_0)
+        print("density = 1000:  output=%g  time=%g" % (value_1, time.time()-t_0))
         
         t_0 = time.time()
         canvas.setParam('lores_density', 0.01)
         value_1 = 1.0e8*canvas.getIq(0.1)
-        print "density = 0.00001:  output=%g  time=%g" % (value_1, time.time()-t_0)
-        print
+        print("density = 0.00001:  output=%g  time=%g" % (value_1, time.time()-t_0))
+        print()
     
     
@@ -63,5 +64,5 @@
         #ana_1 = form_factor(q, radius)
         
-        print "q=%g  sim=%g  ana=%g   ratio=%g" % (q, sim_1, ana_1, sim_1/ana_1)
+        print("q=%g  sim=%g  ana=%g   ratio=%g" % (q, sim_1, ana_1, sim_1/ana_1))
     
 def test_2():
@@ -73,5 +74,5 @@
     shell_vol = 4.0/3.0*math.pi*outer_radius*outer_radius*outer_radius - core_vol
     shell_sld = -1.0*core_vol/shell_vol
-    print "Shell SLD", shell_sld
+    print("Shell SLD", shell_sld)
 
     
@@ -126,5 +127,5 @@
         ana_1 = sphere.run(q)
         
-        print "q=%g  sim=%g  ana=%g   ratio=%g" % (q, sim_1, ana_1, sim_1/ana_1)
+        print("q=%g  sim=%g  ana=%g   ratio=%g" % (q, sim_1, ana_1, sim_1/ana_1))
         out.write( "%g  %g  %g\n" % (q, sim_1, ana_1))
 
@@ -168,5 +169,5 @@
         #ana_1 = form_factor(q, radius)
         
-        print "q=%g  sim=%g  ana=%g   ratio=%g" % (q, sim_1, ana_1, sim_1/ana_1)
+        print("q=%g  sim=%g  ana=%g   ratio=%g" % (q, sim_1, ana_1, sim_1/ana_1))
 
 def test_5():
@@ -193,5 +194,5 @@
     ana = ana.runXY([0.1, 0.1])
     sim = model.getIq2D(0.1, 0.1)
-    print ana, sim, sim/ana, ana/sim
+    print(ana, sim, sim/ana, ana/sim)
 
 def test_6():
@@ -232,5 +233,5 @@
     
     
-    print model.npts
+    print(model.npts)
     for i in range(40):
         qmax = 0.5
@@ -240,9 +241,9 @@
         anaY = ana.runXY([0, qmax*i/40.0])
         simY = model.getIq2D(0, qmax*i/40.0)
-        print anaX, simX, simX/anaX, '|', anaY, simY, simY/anaY
+        print(anaX, simX, simX/anaX, '|', anaY, simY, simY/anaY)
     
 def test_7():
     from sas.models.CoreShellModel import CoreShellModel
-    print "Testing core-shell"
+    print("Testing core-shell")
     radius = 15
     thickness = 5
@@ -287,5 +288,5 @@
         ana_val = ana.runXY([q, 0.2])
         sim_val, err = canvas.getIq2DError(q, 0.2)
-        print ana_val, sim_val, sim_val/ana_val, err, (sim_val-ana_val)/err
+        print(ana_val, sim_val, sim_val/ana_val, err, (sim_val-ana_val)/err)
     
     
Index: test/sasrealspace/test/sim_validation.py
===================================================================
--- test/sasrealspace/test/sim_validation.py	(revision ac07a3acc20dbf79c564bf642aece71a02c2c862)
+++ test/sasrealspace/test/sim_validation.py	(revision aaf5e497ff1af2aa7b8b3d361ab951e2a0ca7c93)
@@ -5,11 +5,13 @@
     @license: This software is provided as part of the DANSE project
 """
+from __future__ import print_function
+
 import math, time, pylab
 
 try:
     import VolumeCanvas
-    print "Testing local version"
+    print("Testing local version")
 except:
-    print "Testing installed version"
+    print("Testing installed version")
     import sas.sascalc.realspace.VolumeCanvas as VolumeCanvas
      
@@ -250,6 +252,6 @@
         ana = validator.run_ana(q)
         sim, err = validator.run_sim(q)
-        print "q=%-g  ana=%-g  sim=%-g  err=%-g  diff=%-g (%-g) %s" % (q, ana, sim, err, 
-                        (sim-ana), sim/ana, str(math.fabs(sim-ana)>err))
+        print("q=%-g  ana=%-g  sim=%-g  err=%-g  diff=%-g (%-g) %s" % (q, ana, sim, err, 
+                        (sim-ana), sim/ana, str(math.fabs(sim-ana)>err)))
         output.write("%g  %g  %g  %g\n" % (q, ana, sim, err))
     output.close()
@@ -278,8 +280,8 @@
         ana = validator.run_ana2D(q*math.cos(phi), q*math.sin(phi))
         sim, err = validator.run_sim2D(q*math.cos(phi), q*math.sin(phi))
-        print "q=%-g  ana=%-g  sim=%-g  err=%-g  diff=%-g (%-g) %s" % (q, ana, sim, err, 
-                        (sim-ana), sim/ana, str(math.fabs(sim-ana)>err))
+        print("q=%-g  ana=%-g  sim=%-g  err=%-g  diff=%-g (%-g) %s" % (q, ana, sim, err, 
+                        (sim-ana), sim/ana, str(math.fabs(sim-ana)>err)))
         output.write("%g  %g  %g  %g\n" % (q, ana, sim, err))
-    print "Time elapsed: ", time.time()-t_0
+    print("Time elapsed: ", time.time()-t_0)
     output.close()
        
@@ -306,7 +308,7 @@
     for d in d_list:
         sim, err = validator.run_sim(q, density=d)
-        print "d=%-g  ana=%-g  sim=%-g  err=%-g  diff=%-g (%g) %s" % \
+        print("d=%-g  ana=%-g  sim=%-g  err=%-g  diff=%-g (%g) %s" % \
             (d, ana, sim, err, (sim-ana), (sim-ana)/ana, 
-             str(math.fabs(sim-ana)>err))
+             str(math.fabs(sim-ana)>err)))
         output.write("%g  %g  %g  %g \n" % (d, ana, sim, err))
     output.close()
Index: test/sasrealspace/test/utest_oriented.py
===================================================================
--- test/sasrealspace/test/utest_oriented.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ test/sasrealspace/test/utest_oriented.py	(revision aaf5e497ff1af2aa7b8b3d361ab951e2a0ca7c93)
@@ -3,4 +3,5 @@
     @copyright: University of Tennessee, for the DANSE project
 """
+from __future__ import print_function
 
 import unittest, math, sys
@@ -16,9 +17,9 @@
 try:
     import VolumeCanvas
-    print "Testing local version"
+    print("Testing local version")
 except:
-    print sys.exc_value
+    print(sys.exc_value)
     #testing the version that is working on
-    print "Testing installed version"
+    print("Testing installed version")
     import sas.sascalc.realspace.VolumeCanvas as VolumeCanvas
  
@@ -241,5 +242,5 @@
             self.assert_( math.fabs(sim_val/ana_val-1.0)<0.05 )
         except:
-            print "Error", ana_val, sim_val, sim_val/ana_val
+            print("Error", ana_val, sim_val, sim_val/ana_val)
             raise sys.exc_type, sys.exc_value
 
@@ -395,5 +396,5 @@
             self.assert_( math.fabs(sim_val/ana_val-1.0)<0.05 )
         except:
-            print "Error", ana_val, sim_val, sim_val/ana_val
+            print("Error", ana_val, sim_val, sim_val/ana_val)
             raise sys.exc_type, sys.exc_value
 
@@ -407,5 +408,5 @@
             self.assert_( math.fabs(sim_val/ana_val-1.0)<0.05 )
         except:
-            print "Error", ana_val, sim_val, sim_val/ana_val
+            print("Error", ana_val, sim_val, sim_val/ana_val)
             raise sys.exc_type, sys.exc_value
 
@@ -419,5 +420,5 @@
             self.assert_( math.fabs(sim_val/ana_val-1.0)<0.05 )
         except:
-            print "Error", ana_val, sim_val, sim_val/ana_val
+            print("Error", ana_val, sim_val, sim_val/ana_val)
             raise sys.exc_type, sys.exc_value
 
@@ -431,5 +432,5 @@
             self.assert_( math.fabs(sim_val/ana_val-1.0)<0.05 )
         except:
-            print "Error", ana_val, sim_val, sim_val/ana_val
+            print("Error", ana_val, sim_val, sim_val/ana_val)
             raise sys.exc_type, sys.exc_value
 
Index: test/sasrealspace/test/utest_realspace.py
===================================================================
--- test/sasrealspace/test/utest_realspace.py	(revision 45dffa69cb5935e2da7c77a2f040debb07ceb1c6)
+++ test/sasrealspace/test/utest_realspace.py	(revision aaf5e497ff1af2aa7b8b3d361ab951e2a0ca7c93)
@@ -3,4 +3,5 @@
     @author: Mathieu Doucet / UTK
 """
+from __future__ import print_function
 
 import unittest, math, time
@@ -15,10 +16,10 @@
 try:
     import VolumeCanvas
-    print "Testing local version"
+    print("Testing local version")
 except:
     import sys
-    print sys.exc_value
+    print(sys.exc_value)
     #testing the version that is working on
-    print "Testing installed version"
+    print("Testing installed version")
     import sas.sascalc.realspace.VolumeCanvas as VolumeCanvas
      
Index: test/utest_sasview.py
===================================================================
--- test/utest_sasview.py	(revision 959eb0181ad06828a748f04512f953aad5b31659)
+++ test/utest_sasview.py	(revision aaf5e497ff1af2aa7b8b3d361ab951e2a0ca7c93)
@@ -1,3 +1,5 @@
 #!/usr/bin/env python
+from __future__ import print_function
+
 import os
 import subprocess
@@ -80,24 +82,24 @@
                     if has_failed:
                         failed += 1
-                        print "Result for %s (%s): FAILED" % (module_name, module_dir)
-                        print std_out
+                        print("Result for %s (%s): FAILED" % (module_name, module_dir))
+                        print(std_out)
                     else:
                         passed += 1
-                        print "Result for %s: SUCCESS" % module_name
+                        print("Result for %s: SUCCESS" % module_name)
 
-    print "\n----------------------------------------------"
+    print("\n----------------------------------------------")
     if n_tests == 0:
-        print "No tests."
+        print("No tests.")
     else:
-        print "Results by test modules:"
-        print "    PASSED: %d" % passed
+        print("Results by test modules:")
+        print("    PASSED: %d" % passed)
         ratio = 100.0*failed/(failed+passed)
-        print "    FAILED: %d    (%.0f%%)" % (failed,ratio)
+        print("    FAILED: %d    (%.0f%%)" % (failed,ratio))
 
-        print "Results by tests:"
-        print "    Tests run:    %d" % n_tests
-        print "    Tests failed: %d" % n_failures
-        print "    Test errors:  %d" % n_errors
-    print "----------------------------------------------"
+        print("Results by tests:")
+        print("    Tests run:    %d" % n_tests)
+        print("    Tests failed: %d" % n_failures)
+        print("    Test errors:  %d" % n_errors)
+    print("----------------------------------------------")
     
     return failed
